class T2MacroCPU < T2CPU
	def decode_instruction(foo, addr)
		ndi = no = na = nil
		dec_next = proc { |di|
			ndi = decode_instruction(foo, di.next_addr)
			no = ndi.instruction.opname if ndi
			na = ndi.instruction.args if ndi
			ndi
		}
		di = super
		di = dec_next[di] while di and di.next_addr and (di.instruction.opname == 'nop' or di.instruction.opname == 'trap')
		di.address = addr if di
		return di if not di or not di.next_addr

		loop do
			o = di.instruction.opname
			a = di.instruction.args
			i = di.instruction
			if o == 'decryptcopy' and a.length == 4
				dst, off, key, count = a
				str = ''
				key = key.reduce
				count = count.reduce
				off = off.reduce
				edata = @ia32dasm.get_section_at(0x13000+off)[0]
				while count > 0
					nkey = (((key << count) | (key >> (32-count))) + count) & 0xffff_ffff
					count -= 1
					edata.ptr = off + 4*count
					str[0, 0] = [edata.decode_imm(:u32, :little) ^ key].pack('V')
					key = nkey
				end
				di.instruction.args = [dst, str.inspect]
			elsif o == 'mov' and a == [:r68, Expression[4]] and
					dec_next[di] and no == 'mov' and na.first == Indirection[:esp, 4] and na.last.kind_of? Expression and
					dec_next[ndi] and no == 'add' and na == [:esp, :r68]
				pushed = []
				ndi = di
				while dec_next[ndi] and no == 'mov' and na.first == Indirection[:esp, 4]
					pushed << na.last
					if not dec_next[ndi] or no != 'add' or na != [:esp, :r68]
						pushed.pop
						break
					end
				end
				break if pushed.length < 3 or no != 'mov' or na != [:ebp, :esp]
				i.opname = 'call'
				di.opcode = di.opcode.dup
				di.opcode.props = di.opcode.props.merge :saveip => true, :pushed => pushed
				a.replace [ndi.next_addr, *pushed[3..-1]]
			elsif o == 'mov' and a == [:r68, Expression[4]] and
					# call resolution with mov/add grouping disabled, just to count un-macroed vm instructions
					dec_next[di] and no == 'mov' and na.first == :r64 and na.last.kind_of? Expression and
					dec_next[ndi] and no == 'mov' and na == [Indirection[:esp, 4], :r64] and
					dec_next[ndi] and no == 'add' and na == [:esp, :r68] and
					dec_next[ndi] and no == 'mov' and na.first == :r64 and na.last.kind_of? Expression and
					dec_next[ndi] and no == 'mov' and na == [Indirection[:esp, 4], :r64] and
					dec_next[ndi] and no == 'add' and na == [:esp, :r68] and
					dec_next[ndi] and no == 'mov' and na == [Indirection[:esp, 4], :ebp] and
					dec_next[ndi] and no == 'add' and na == [:esp, :r68]
				pushed = []
				foo = nil
				ndi = di
				lastdi = nil
				while dec_next[ndi]
					if no == 'mov' and na.first == :r64
						foo = na.last
					elsif no == 'add' and na.first == :esp
						if na.last == :r68
							pushed << foo
							lastdi = ndi
						else
							break
						end
					end
				end
				break if pushed.length < 3
				dec_next[lastdi]
				i.opname = 'call'
				di.opcode = di.opcode.dup
				di.opcode.props = di.opcode.props.merge :saveip => true, :pushed => pushed
				a.replace [ndi.next_addr, *pushed[3..-1]]
			elsif o == 'mov' and a == [:r64, Expression[-4]] and
					dec_next[di] and no == 'add' and na == [:esp, :r64] and
					dec_next[ndi] and no == 'mov' and na == [:ebp, Indirection[:esp, 4]] and
					dec_next[ndi] and no == 'add' and na == [:esp, :r64] and
					dec_next[ndi] and no == 'mov' and na == [:r68, Indirection[:esp, 4]] and
					dec_next[ndi] and no == 'add' and na == [:esp, :r64] and
					dec_next[ndi] and no == 'mov' and na == [:r6c, Indirection[:esp, 4]] and
					dec_next[ndi] and no == 'jmp' and
					na == [T2Addr[Expression[:r68, :+, 0x13000], Expression[:r6c, :+, 0x13000]]]
				di.instruction.opname = 'ret'
				a.replace []
			elsif o == 'mov' and a == [:r64, :esp] and
					dec_next[di] and no == 'seteql' and na == [:r64, :esp_init] and
					dec_next[ndi] and no == 'xor' and na == [:r64, Expression[1]] and
					dec_next[ndi] and no == 'jrz' and na.last == :r64 and fa = na.first and
					dec_next[ndi] and no == 'ret'
				i.opname = 'ret'
				a.replace [fa]
			elsif o == 'mov' and [:r64, :r68, :r6c, :r78].include? a.first
				break if not dec_next[di]
				if no == 'add' and na.first == a.first
					a[1] = Expression[Expression[a[1], :+, na[1]].reduce]
				elsif %w[add setgt setlt seteql shr and mul xor mov jrz syscall_free syscall_alloc_ptr host_push].include? no and
						Expression[na.last].externals.include? a.first
					bd = {a.first => Expression[a.last]}
					i.opname = no
					a.replace na
					a[-1] = Expression[Expression[a[-1]].bind(bd).reduce]
				elsif %w[add setgt setlt seteql shr and mul xor mov].include? no and
						Expression[na.first].reduce_rec.kind_of? Indirection and
						Expression[na.first].externals.include? a.first
					bd = {a.first => Expression[a.last]}
					i.opname = no
					a.replace na
					a[0] = Expression[Expression[a[0]].bind(bd).reduce]
				elsif %w[add setgt setlt seteql shr and mul xor].include? no and
						na.first == a.first and
						dec_next[ndi] and no == 'mov' and na == a.reverse
					dec_next[di]
					i.opname = no
					a[0] = a.last
					a[1] = na[1]
					dec_next[ndi]
				elsif no == 'syscall_md5' and na.find { |aa| Expression[aa].externals.include? a.first }
					i.opname = no
					a.replace na.map { |aa| aa == a.first ? a.last :
						Expression[aa].externals.include?(a.first) ?
						Expression[Expression[aa].bind(a.first => a.last).reduce] : aa }
				else
					break
				end
			else
				break
			end
			di.next_addr = ndi.next_addr if ndi
		end

		di
	end

	def get_xrefs_x(dasm, di)
		if di.instruction.opname == 'ret'
			[T2Addr[Expression[0x13000, :+, Indirection[[:esp, :-,  8], 4, di.address]],
			      Expression[0x13000, :+, Indirection[[:esp, :-, 12], 4, di.address]]]]
		else
			[]
		end + super
	end

	def backtrace_binding(di)
		case di.instruction.opname
		when 'ret':  {:esp => Expression[:esp, :-, 12], :ebp => Expression[Indirection[[:esp, :-, 4], 4, di.address]]}
		when 'call'
			esp = Expression[:esp]
			h = {}
			di.opcode.props[:pushed].reverse_each { |p| h[Indirection[(esp -= 4), 4, di.address]] = Expression[p] }
			h.update :esp => Expression[:esp, :+, di.opcode.props[:pushed].length*4]
		else super
		end
	end

	def backtrace_is_stack_address(expr)
		not (Expression[expr].expr_externals & [:esp, :ebp]).empty?
	end

	def backtrace_is_function_return(expr, di=nil)
		expr = Expression[expr].reduce_rec
		expr.kind_of? T2Addr and expr.ip.externals == [:esp]
	end
	
	def backtrace_update_function_binding(dasm, faddr, func, retaddrlist)
		func.backtrace_binding[:r64] = func.backtrace_binding[:r68] = func.backtrace_binding[:r78] = Expression::Unknown
		[:retval, :esp, :ebp].each { |r|
			v = []
			retaddrlist.each { |retaddr|
				v |= dasm.backtrace(r, retaddr, :include_start => true, :snapshot_addr => faddr)
			}
			if v.length != 1 or func.backtrace_binding.fetch(r, v.first) != v.first
				func.backtrace_binding[r] = Expression::Unknown
			else
				func.backtrace_binding[r] = Expression[v.first]
			end
		}
	end
end
